.386

.MODEL FLAT,STDCALL
OPTION CASEMAP :NONE

Include	EzPrompt.inc

;Include masm32.inc
;Include debug.inc
;IncludeLib masm32.lib
;IncludeLib debug.lib

.CODE

Start:
	Invoke GetModuleHandle,NULL
	MOV hInstance, EAX
	Invoke DialogBoxParam,hInstance,IDD_MAIN,0,Offset DlgProc,0
	Invoke ExitProcess,EAX

ErrorMessage Proc
Local lpErrorMessage:DWORD
	CALL GetLastError
	LEA EDX,lpErrorMessage
	Invoke FormatMessage, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM, NULL, EAX, LANG_NEUTRAL,EDX,0,NULL
	Invoke MessageBox,0, lpErrorMessage,0, MB_OK
	Invoke LocalFree, lpErrorMessage
	RET
ErrorMessage EndP

CreateProcessAndPipe Proc Uses EBX
Local BytesWritten	:DWORD

	Invoke GetEnvironmentVariable,Offset szCOMSPEC,Offset szCommand,MAX_PATH
	MOV sat.nLength,SizeOf SECURITY_ATTRIBUTES
	MOV sat.lpSecurityDescriptor,NULL
	MOV sat.bInheritHandle,TRUE
	
	Invoke CreatePipe,ADDR hReadIn,ADDR hWriteIn,ADDR sat,1024
	.If EAX
		Invoke CreatePipe,ADDR hReadOut,ADDR hWriteOut,ADDR sat,1024
		.If !EAX
			PUSH EAX
			Invoke CloseHandle,hReadIn
			Invoke CloseHandle,hWriteIn
			POP EAX
		.EndIf
	.EndIf
	
	.If EAX==NULL
		;CreatePipe failed
		Invoke ErrorMessage
		MOV EAX,FALSE
	.Else
		Invoke RtlZeroMemory,ADDR StartupInfo,SizeOf STARTUPINFO
		Invoke RtlZeroMemory,ADDR ProcessInfo,SizeOf PROCESS_INFORMATION
		
		MOV StartupInfo.cb,SizeOf STARTUPINFO
		MOV StartupInfo.dwFlags,STARTF_USESTDHANDLES+STARTF_USESHOWWINDOW
		
		MOV EAX,hWriteOut
		MOV StartupInfo.hStdOutput,EAX
		MOV StartupInfo.hStdError,EAX
		
		MOV EAX,hReadIn
		MOV StartupInfo.hStdInput,EAX
		MOV StartupInfo.wShowWindow,SW_HIDE
		
		Invoke CreateProcess,NULL,Offset szCommand,NULL,NULL,TRUE,NULL,NULL,NULL,ADDR StartupInfo,ADDR ProcessInfo
		
		.If !EAX
			;CreateProcess failed
			Invoke ErrorMessage
			Invoke CloseHandle,hReadIn
			Invoke CloseHandle,hWriteOut
			Invoke CloseHandle,hReadOut
			Invoke CloseHandle,hWriteIn
			MOV EAX,FALSE
		.Else
			Invoke CloseHandle,hReadIn
			Invoke CloseHandle,hWriteOut
			
			Invoke CloseHandle,ProcessInfo.hProcess
			Invoke CloseHandle,ProcessInfo.hThread
			
			MOV EAX,TRUE
		.EndIf
		
	.EndIf

	RET
CreateProcessAndPipe EndP

EditProc Proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
Local BytesWritten		:DWORD

	.If uMsg==WM_KEYDOWN && wParam==VK_RETURN
		PUSH EBX
		Invoke SendMessage,hWin,WM_GETTEXT,MAX_PATH,Offset szCommand
		MOV EBX,EAX
		.If szCommand[0]!=0
			Invoke SendMessage,	hComboInput,CB_FINDSTRINGEXACT,-1,Offset szCommand
			.If EAX==CB_ERR
				Invoke SendMessage,	hComboInput,CB_ADDSTRING,0,Offset szCommand
			.EndIf
		.EndIf
		Invoke lstrcmpi,Offset szCommand,Offset szCLS
		.If !EAX
			Invoke SendMessage,hEditOutput,WM_SETREDRAW,FALSE,0
			Invoke SendMessage,hEditOutput,WM_SETTEXT,0,Offset szNULL
			Invoke WriteFile,hWriteIn,Offset szCR,2,ADDR BytesWritten ,NULL
		.Else
			Invoke lstrcat,Offset szCommand,Offset szCR
			ADD EBX,2
			Invoke WriteFile,hWriteIn,Offset szCommand,EBX,ADDR BytesWritten ,NULL
		.EndIf
		
		Invoke SendMessage,hWin,WM_SETTEXT,0,Offset szNULL
		POP EBX
		XOR EAX,EAX
		RET
		
	.ElseIf uMsg==WM_CHAR
		Invoke GetKeyState,VK_CONTROL
		AND EAX,80h
		.If EAX==80h
			MOV EAX,wParam
			MOV szCommand[0],AL
			MOV szCommand[1],0Dh
			MOV szCommand[2],0Ah
			Invoke WriteFile,hWriteIn,Offset szCommand,3,ADDR BytesWritten ,NULL
			XOR EAX,EAX
			RET
		.EndIf
		
	.ElseIf uMsg==WM_GETDLGCODE
		MOV EAX,DLGC_WANTALLKEYS
		RET
	.EndIf 
	
	Invoke GetWindowLong,hWin,GWL_USERDATA 
	Invoke CallWindowProc,EAX,hWin,uMsg,wParam,lParam 
	
	RET
EditProc EndP


DlgProc Proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
Local BytesWritten	:DWORD
Local nTotalBytes	:DWORD
Local BytesRead		:DWORD

	MOV	EAX,uMsg
	.If	EAX == WM_INITDIALOG
		Invoke CreateProcessAndPipe
		.If EAX
			Invoke LoadIcon,hInstance,200
			Invoke SendMessage,hDlg,WM_SETICON,1,EAX
			
			Invoke GetDlgItem,hDlg,IDC_EDITOUTPUT
			MOV hEditOutput,EAX
			
			Invoke GetDlgItem,hDlg,IDC_CBOINPUT
			MOV hComboInput,EAX
			Invoke GetWindow,EAX,GW_CHILD
			MOV hEditInput,EAX
			
			Invoke SetWindowLong,hEditInput,GWL_WNDPROC,Offset EditProc
			Invoke SetWindowLong,hEditInput,GWL_USERDATA,EAX
			
			Invoke SetFocus,hEditInput
			
			Invoke SetTimer,hDlg,100,100,NULL
			;Prevent Windows from setting the default keyboard focus
			MOV EAX,FALSE
			RET
		.Else
			Invoke EndDialog,hDlg,0
		.EndIf
	.ElseIf EAX==WM_TIMER
		
		@@:
		Invoke PeekNamedPipe,hReadOut,NULL,NULL,NULL,ADDR nTotalBytes,NULL
		.If nTotalBytes
			Invoke ReadFile,hReadOut,Offset Buffer,nTotalBytes,ADDR BytesRead,NULL
			.If EAX
				MOV ECX,Offset Buffer
				ADD ECX,BytesRead
				MOV BYTE PTR [ECX],0
				Invoke SendMessage,hEditOutput,WM_SETREDRAW,FALSE,0
				Invoke SendMessage,hEditOutput,EM_REPLACESEL,FALSE,Offset Buffer
				Invoke SendMessage,hEditOutput,WM_SETREDRAW,TRUE,0
				Invoke SendMessage,hEditOutput,EM_SCROLLCARET,0,0
				JMP @B
			.EndIf
		.EndIf
		
	.ElseIf	EAX == WM_CLOSE
		Invoke EndDialog,hDlg,0
		
		Invoke WriteFile,hWriteIn,Offset szExit,6,ADDR BytesWritten ,NULL
		Invoke Sleep,1000
		
		Invoke CloseHandle,hWriteIn
		Invoke CloseHandle,hReadOut
		
	.ElseIf EAX==WM_CTLCOLOREDIT 
		Invoke SetTextColor,wParam,White 
		Invoke SetBkColor,wParam,Black 
		Invoke GetStockObject,BLACK_BRUSH 
		RET
		
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	MOV EAX,TRUE
	RET
DlgProc EndP

End Start